<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Order extends CI_Controller {
    public function __construct() 
    {
        error_reporting(0);
        parent::__construct();
        $this->load->library('Multiquery');  
    }
    public function filters(){
        $status = $this->db->get('ptsl_accountstatus')->result_array();
        $channel = $this->db->get('ptsl_accountchannel')->result_array();
        $type = $this->db->get('ptsl_order_status')->result_array();
        $data['status'] = $status;
        $data['channel'] = $channel;
        $data['type'] = $type;
        $user_id = @$this->input->get('user_id');
        $spn = "Call ptsl_sp_get_brand_list('".$user_id."')";
        $res = $this->multiquery->GetResults($spn);
        $data['brands'] = $res[2];
        $response = array(
                'status' => TRUE,
                'filters' => $data
            );
            echo json_encode($response);
    }
    public function get_skus($supplier_id,$account_id){
        $call = "CALL ptsl_sp_get_items_for_order('".$supplier_id."','".$account_id."')";
        $data = $this->db->query($call)->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'skus' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
    }
    public function save(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        //$post_data= $this->input->post();
        $sku = @$post_data['sku'];
        $qty = @$post_data['qty'];
        $order_by = @$post_data['order_by'];
        $phone_no = @$post_data['phone_no'];
        $dist_rep_id = @$post_data['dist_id'];
        $acc_id  = @$post_data['acc_id'];
        $internal_acc_id = @$post_data['internal_acc_id'];
        $user_id = @$post_data['user_id'];
        $supplier_id = @$post_data['supplier_id'];
        $data = array(
            'item_id' => $sku,
            'qty' => $qty,
            'who_ordered_it' => $order_by,
            'phone_no_of_person_who_order' => $phone_no,
            'user_id' => $user_id,
            'distributor_rep_id' =>$dist_rep_id,
            'account_id' => $acc_id,
            'internal_account_id' => $internal_acc_id,
            'created_by' => $user_id,
            'order_date' => date("Y-m-d H:i:s"),
            'order_status_id' => 1,
            'created_date' => date("Y-m-d H:i:s"),
            'supplier_id' => $supplier_id
        );
        $res = $this->db->insert('ptsl_orders',$data);
        $order_id = $this->db->insert_id();
        //find dist_rep_device
        
        $this->db->select('push.device_key');
        $this->db->from('ptsl_push_notifications push');
        $this->db->join('ptsl_users u','u.user_id=push.user_id','left');
        $this->db->where('u.distributor_rep_id',$dist_rep_id);
        $this->db->join('ptsl_user_settings us','u.user_id=us.user_id','');
        $this->db->where('us.allow_notification',1);
        $devices = $this->db->get()->result_array();
        $this->db->where('order_id',$order_id);
        $acc_data = $this->db->get('ptsl_vw_orders')->row();
        $push_mmsg = "An order has been created for ".$acc_data->LongName." by ".$acc_data->order_creator_name;
        $this->db->select('user_id');
            $notification_gotten_user_info = $this->db->get_where('ptsl_users',array('distributor_rep_id'=> $dist_rep_id))->row();
        //insert into notification table
         $notification_data = array(
                'user_id' => $notification_gotten_user_info->user_id,
                'notification' => $push_mmsg,
                'notification_url' => '#/order_details/'.$order_id,
                'created_date' => date('Y-m-d H:i:s')
            );
            $this->db->insert('ptsl_user_notifications',$notification_data); 
        
        if($res){
            $response = array(
                'status' => TRUE,
                'message' => 'Success'
            );
            echo json_encode($response);
            $send_push = $this->send_push($devices,$order_id,$push_mmsg);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
         
    }
    public function order_list(){
        $user_id = @$this->input->get('user_id');
        $order_status = @$this->input->get('order_status');
        $status = @$this->input->get('status');
        $state = @$this->input->get('state');
        $brand = @$this->input->get('brand');
        $channel = @$this->input->get('channel'); 
        $drep = @$this->input->get('drep'); 
        $dmanager = @$this->input->get('dmanager'); 
        $region ="";
        $supplier_rep =@$this->input->get('rep'); 
        $spn = "Call ptsl_sp_get_orders('".$user_id."','".$status."','".$channel."','".$order_status."','".$state."','".$region."','".$supplier_rep."','".$brand."','".$dmanager."','".$drep."')";
        $data = $this->multiquery->GetResults($spn);
       // print_r($data);
        if($data){
            $response = array(
                'status' => TRUE,
                'orders' => $data[2]
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
    }
    public function order_details($id){
        
        $this->db->where('order_id',$id);
        $data = $this->db->get('ptsl_vw_orders')->row();
        if($data){
            $response = array(
                'status' => TRUE,
                'order' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
    }
    public function change_status(){
        $id = $this->input->get('order_id');
        $user_id = $this->input->get('user_id');
        $data =array(
            'approved_date' => date("Y-m-d H:i:s"),
            'approved_by'   => $user_id,
            'order_status_id' => 2
        );
        $this->db->where('id',$id);
        $res = $this->db->update('ptsl_orders',$data);
        if($res){
            $this->db->where('id',$id);
            $order_info = $this->db->get('ptsl_orders')->row();
            $this->db->select('push.device_key');
            $this->db->from('ptsl_push_notifications push');
            
            $this->db->join('ptsl_orders o','o.user_id=push.user_id','');
            $this->db->join('ptsl_user_settings us','push.user_id=us.user_id','');
            $this->db->where('us.allow_notification',1);
            $this->db->where('o.user_id',$order_info->user_id);
            $devices = $this->db->get()->result_array();
            $this->db->where('order_id',$id);
            $acc_data = $this->db->get('ptsl_vw_orders')->row();
            //$this->db->select('user_id');
            //$notification_gotten_user_info = $this->db->get_where('ptsl_users',array('supplier_rep_id'=> $order_info->supplier_rep_id))->row();
            $push_mmsg = "Your order has beeen approved by  ".$acc_data->dist_rep_name;
            $notification_data = array(
            'user_id' => $order_info->user_id,
            'notification' => $push_mmsg,
            'notification_url' => "#/order_details/".$id,
            'created_date' => date('Y-m-d H:i:s')
        );
        $this->db->insert('ptsl_user_notifications',$notification_data); 
            
           
            $response = array(
                'status' => TRUE,
                'message' => "Updated"
            );
            echo json_encode($response);
            $send_push = $this->send_push($devices,$id,$push_mmsg);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
    }
    public function get_dist_manager_rep($user_id){
        $supplier_id = '';
        $spn = "call ptsl_sp_load_distributor_manager_rep('".$user_id."','".$supplier_id."')";
        $data = $this->multiquery->GetResults($spn);
        if($data){
            $response = array(
                'status' => TRUE,
                'dist_manager'=>$data[2],
                'dist_reps'=>$data[3],
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
        
    }
    public function remove_player(){
        $user_id = $this->input->get('user_id');
        $player_id = $this->input->get('player_id');
        $this->db->where('user_id',$user_id);
        $this->db->where('device_key',$player_id);
        $res = $this->db->delete('ptsl_push_notifications');
        if($res){
            $response = array(
                'status' => TRUE,
                'message' => 'Player Removed'
            );
            echo json_encode($response);
        }
    }
    private function send_push($devices_associative_arr,$order_id,$msg){
        $devices =array();
        foreach ($devices_associative_arr as $key => $device) {
            array_push($devices, $device['device_key']);
        }
    
        $content = array(
          "en" => $msg
          );
        
       $fields = array(
      'app_id' => "e13a6f2b-74f2-4cb8-a109-b4af95c293ce",
     // 'included_segments' => array('All'),
      //'included_segments' => array('789e714d-7e95-4a1f-a65c-75f967f442a3'),
      'include_player_ids' => $devices,
      'data' => array("state" => "order_details","param"=>$order_id,"type_id"=>1),
      'contents' => $content,
      "ios_badgeType" => "Increase",
      "ios_badgeCount"=> 1
  

    );
        
        $fields = json_encode($fields);
        //print("\nJSON sent:\n");
        //print($fields);
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://onesignal.com/api/v1/notifications");
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8',
                               'Authorization: Basic OTQ0YWM4ODQtNjNjZi00MzJjLThhMjgtZjdiZTcyYWY3YTJl'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        $response = curl_exec($ch);
        curl_close($ch);
        
        return $response;
    } 
}